// Fichier MainBoard.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                  librairie				            *
 *					de mesure de tension  batterie		*
 *                                                      *
 * .Date de cration : 21/01/08                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *														*
 *                                                      *
 *                                                      *
 * .Remarques :       									*
 *                                                      * 
 * ATTENTION : Les convertisseurs Analogiques/Numriques*
 * doivent avoir t configurs							*
 *                                                      *
 ********************************************************/


#include <adc.h>

#include "CAN.h"


// --------------------------------------------------------------------------
/* Fonction BatterieLogique
 * Retourne le rsultat brut de la conversion
 * de la tension batterie logique (12V)
 * Equation approxime de la conversion : U[V]=0.025781.X
 *  0    : 0V
 *  1023 : environ 19.7 V
*/
int BatterieLogique(void)
{
	return (CAN_Convert(ADC_CH2));
}



// --------------------------------------------------------------------------
/* Fonction BatterieLogiqueVolt
 * Retourne la tension de la batterie logique (12V) en Volts
*/
float BatterieLogiqueVolt(void)
{
	return (CAN_Convert(ADC_CH2)*0.019279);
}






// --------------------------------------------------------------------------
/* Fonction BatteriePuissance
 * Retourne le rsultat brut de la conversion
 * de la tension batterie logique (18.5V)
 * Equation approxime de la conversion : U[V]=0.025781.X
 *  0    : 0V
 *  1023 : environ 25.8 V
*/
int BatteriePuissance(void)
{
	return (CAN_Convert(ADC_CH3));
}



// --------------------------------------------------------------------------
/* Fonction BatteriePuissanceVolt
 * Retourne la tension de la batterie logique (18.5V) en Volts
*/
float BatteriePuissanceVolt(void)
{
	return (CAN_Convert(ADC_CH3)*0.025272);
}