// Fichier MainBoard.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                 Header de la librairie               *
 *					de mesure de tension  batterie		*
 *                                                      *
 * .Date de cration : 21/01/08                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *														*
 *                                                      *
 *                                                      *
 * .Remarques :       									*
 *                                                      * 
 * ATTENTION : Les convertisseurs Analogiques/Numriques*
 * doivent avoir t configurs							*
 *                                                      *
 ********************************************************/

#ifndef __BATTERIES_H_
#define __BATTERIES_H_



// --------------------------------------------------------------------------
/* Fonction BatterieLogique
 * Retourne le rsultat brut de la conversion
 * de la tension batterie logique (12V)
 * Equation approxime de la conversion : U[V]=0.025781.X
 *  0    : 0V
 *  1023 : environ 26.374 V
*/
int BatterieLogique(void);


// --------------------------------------------------------------------------
/* Fonction BatterieLogiqueVolt
 * Retourne la tension de la batterie logique (12V) en Volts
*/
float BatterieLogiqueVolt(void);





// --------------------------------------------------------------------------
/* Fonction BatteriePuissance
 * Retourne le rsultat brut de la cenversion
 * de la tension batterie logique (18.5V)
 * Equation approxime de la conversion : U[V]=0.025781.X
 *  0    : 0V
 *  1023 : environ 26.374 V
*/
int BatteriePuissance(void);



// --------------------------------------------------------------------------
/* Fonction BatteriePuissanceVolt
 * Retourne la tension de la batterie logique (18.5V) en Volts
*/
float BatteriePuissanceVolt(void);

#endif