// Fichier Robot.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/



#define 	ADR_I2C_CANON		0xDC		// Adresse IC du rouleau droit

// a definir ...
#define		CHECK_UP_VITESSE_CANON		30		// Vitesse applique sur les rouleaux
#define		CHECK_UP_MESURE_CANON		29		// Vitesse mesure minimum
#define 	CHECK_UP_DELAY				50		// Delai pour permettre au moteur d'atteindre sa vitesse 





// --------------------------------------------------------------------------
/* Commande le canon
 * 	Speed : moteur canon (vitesse entre -128 et +127)
 * Paramtre retourn : 
 *   0 : Tout s'est bien pass
 * 	-1 : Une collision s'est produite sur le BUS IC ou l'esclave n'a pas renvoy d'acknoledgment aprs l'adresse
 *  -2 : L'esclave n'a pas envoy d'acknoledgement aprs une donne
*/
int Commande_Canon(unsigned char Speed);	




// --------------------------------------------------------------------------
/* Mesure la vitesse du canon
 * La fonction mesure la vitesse du canon
 *  entre -128 et +127 si tout s'est bien pass
 * 	0x0FFF en cas de problme dans la transmission
*/
int Mesure_Canon(void);


// --------------------------------------------------------------------------
/* Mesure la vitesse moyenne du canon sur N mesures
 * La fonction mesure la vitesse du canon
 *  entre -128 et +127 si tout s'est bien pass
 * 	0x0FFF en cas de problme dans la transmission
*/
int Mesure_Moyenne_Canon(int N);


// --------------------------------------------------------------------------
/* Effectue un chek-up du canon
 * Lance le rouleau en avant et vrifie la vitesse   (erreurs 1 et 2)
 * Arrte le moteur et vrifie qu'il est  l'arrt   (erreurs 3 et 4)
 * Lance le rouleau en arrire et vrifie la vitesse (erreurs 5 et 6)
 * Pas de problme : on retourne 0 
*/
unsigned char Check_Up_Canon(void);

