
// Fichier Depart_Bleue.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *					Depart Bleue						*
 *                                                      *
 * .Date de cration : 23/04/08                         *
 * .Auteur : Jrmie LUMINEAU							*       
 *                                                      *
 * .Descriptions :                                      *
 *      - code du dpart bleue							*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <delays.h>
#include "mystdio.h"


#include "strategie_bleu.h"
#include "Depart_bleu.h"
#include "lcd.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "IO.h"
#include "I2C_Master.h"
#include "barillet.h"
#include "Horloge.h"
#include "led.h"
#include "Telemetres.h"
#include "serial.h"
#include "canon.h"
#include "Tourelle.h"
#include "Constante.h"
#include "Distributeur.h"
#include "Recal.h"
#include "Recharge_Barillet_Bleu.h"
#include "Tir.h"
#include "Goto_Conteneur.h"


// --------------------------------------------------------------------------
/* Fonction qui fait la premire phase du match 
 * Ramasse les deux premires balles bleues sur la table
 * puis prend ce qu'il peut sur la table, et enfin, va aux distributeur si
 * ncessaire avant d'aller dposer dans le conteneur standard
*/

void Depart_Bleu( unsigned char	Bad_Robot ){
	unsigned int	etat=0;										// Etat courant de la machine principale
	unsigned char   Etat_Rouleaux=0;							// Etat courant de la machine  tat pour les rouleaux
	char			ret;
	
	char 			i,config=0;									// Position de la balle bleu mobile
	int				MesureTelemetre;							// Distance mesure au tlmtre
	int 			correction=0;								// Correction de la position pour la prise des balles
	int vit=100;
	
	char ismoving=0;
	char propuls;
	char transition=0;
	char adv_devant=0, adv_derriere=0;
	char nb_balles=0;

	float beta;
	int poussee_ok;
	
	StartHorloge();												// Dmarre le chrono sur 90 secondes




	
	Commande_Rouleaux(60, 60);									// Met les rouleaux en marche
	
	
	etat = 0;	
	transition = 1;
	
	while( 1 ){
		
		if( transition ){
			print_strint( ">blanc@", Sec_depuis_debut(), 0 );
			print_strint( "s =", etat, 1 );
		}


			

		// --------------------------------------------------------------
		// Machine  tat pour les rouleaux
		
		switch (Etat_Rouleaux){
			case 0 :  
				if (NbBalles_Barillet(TOUTES)==5) 				// Si on a 5 balles dans le robot
					Etat_Rouleaux=1;							// On change d'tat 
					break;
			case 1 : 
					Commande_Rouleaux(-60, -60);				// On inverse le sens des rouleaux
					Etat_Rouleaux=2;							// On quitte cet tat pour ne pas rexecuter la commande 
					break;
		}
		

		
		// mise  jour des nouvelles conditions de transition :
		propuls = Etat_Propulsion();
		ismoving = propuls!='a' && propuls!='g' && propuls!='o';
		adv_devant = Adversaire_Devant();
		adv_derriere = Adversaire_Derriere();
				
		if( transition==1 )
		{
			Stop_Propulsion();
			while (Etat_Propulsion()!='a');
		}

	
		Delay100TCYx(1);										// Attente entre deux cycles
	
		switch( etat ){
			
				
			case 0:	
				if( transition ){
					GotoXY_Propulsion(2400,700,60);				// se placer en face de notre distri blanc
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 1;	
				}
				break;

			case 1:	
				if( transition ){
					Angle_Propulsion (0,30);						// s'orienter vers le distri blanc
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 2;	
				}
				break;
							
			case 2:	
				if( transition ){
					GotoXY_Propulsion(3000, 750, 80);				// foncer vers le distri blanc
					transition=0;
				}else if( !ismoving || X_Propulsion()>2480 ){
					transition = 1;
					etat = 3;	
				}
				break;
							
			case 3:	
				Distributeur_Blanc_Bleu( 5, 3 );					// prendre les 5 blanches
				transition = 1;
				etat = 31;
				break;

			case 31 :
				if( transition ){
					ToutDroit_Propulsion(100, -40);				// foncer vers le distri blanc
					transition=0;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 4;	
				}
				break;

							
							
			case 4:	
				ret = Goto_Conteneur_Bleu( 1000 );
				transition = 1;
				etat = 5;
				break;
				
			case 5 :
				if( transition ){
					DeposeBalle_Chez_Nous_Barillet();				// dposer les 5 blanches chez nous
					Delay10KTCYx(250);
					transition = 0;
				}else if( !Barillet_Busy() ){		
					transition = 1;
					etat = 6;
				}
				break;
			
			case 6 :
				if( transition && adv_devant<=1 ){
					GotoXY_Propulsion(600, 750, 80);				// aller en face du distri blanc adverse
					transition=0;
				}else if( adv_devant>=2 ){							// si on rencontre l'adversaire
					Stop_Propulsion();
					transition = 1;									
					etat = 60;
				}else if( propuls=='a' ){
					transition = 1;
					etat = 7;	
				}
				break;

			case 60 :	// (l'adversaire est devant nous)
				if( adv_devant<=1 ){								// si l'adversaire n'est plus devant nous
					transition = 1;
					etat = 6;										// repartir	 son distri blanc
				}
				break;
				
			case 7 :	
				if( transition ){
					Angle_Propulsion (PI,30);						// s'orienter vers son distri blanc
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 8;	
				}
				break;
							
			case 8 :	
				Distributeur_Blanc_Rouge( 5, 3 );					// prendre les blanches restantes dans son distri
				transition = 1;
				etat = 81;
				break;
			
			case 81 :
				if( transition ){
					Angle_Propulsion (-PI/2,30);						// s'orienter vers son distri blanc
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 9;	
				}
				break;

			case 9 :	
				ret = Goto_Conteneur_Rouge( 500 );						// retourner de notre ct du conteneur
				transition = 1;
				etat = 10;
				break;
				
			case 10 :
				while (NbBalles_Barillet(BLANCHE)>2)			// tant qu'il reste plus de 2 blanches dans le barillet
				{
					DeposeBalle_Barillet(BLANCHE);				// dposer une blanche
					Delay10KTCYx(250);
					while(Barillet_Busy());
				}
				
				Nb_Balles_Distributeur_Blanc_Rouge = 0;			// pour s'assurer qu'on ne reviendra plus chercher des blanches chez l'adversaire
				
				transition = 1;
				etat = 11;
				break;
			
			case 11 :
				Rechargement_Barillet_Bleu();
				transition = 1;
// TODO				if( Nb_Balles_Distributeur_Bleu>=2 && Sec_depuis_debut()<60 )		// si on a le temps
//					etat = 12;									// on va tirer deux balles bleues
//				else
					etat = 13;									// sinon on part dposer direct
				break;
				
			case 12 :
				Tir2Bleues();										// tirer 2 bleues
				transition = 1;
				etat = 121;											// puis aller faire le complment
				break;
			
			case 121 :
				if( transition ){
					Angle_Propulsion(-PI/2, 30);
					transition = 0;	
				} else if( !ismoving ){
					transition = 1;
					etat = 122;
				}
				break;
				
			case 122 :
				if( transition ){
					GotoXY_Propulsion(2300,0,80);					// aller  notre distri bleu
					transition=0;
				}else if( !ismoving || Y_Propulsion()<400 ){
					transition = 1;
					etat = 123;	
				}
				break;

			case 123:	
				Distributeur_Blanc_Bleu( 1, 2 );					// prendre la seule bleue qui reste
				transition = 1;
				etat = 13;
				break;

			case 13 :
				if( transition ){
					Angle_Propulsion (-PI/4,30);					// s'orienter vers le conteneur
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 131;	
				}
				break;
				
			case 131 :
				ret = Goto_Conteneur_Bleu( 500 );					// retourner de notre ct du conteneur
				transition = 1;
				etat = 14;
				break;
			
			case 14 :
				transition = 1;
				if (X_Propulsion()>1500) 							// Si on est du ct rouge ...
					etat = 20;
				else												// si on est du ct bleu
					etat = 30;
				break;
				
			
			case 20 :
				if( Sec_depuis_debut()>80 ){						// s'il reste moins de 10s
					transition = 1;
					etat = 1000;									// aller dposer
				}
				break;				
			
			case 30 :
				if( Sec_depuis_debut()>80 ){						// s'il reste moins de 10s
					transition = 1;
					etat = 1000;									// aller dposer
				}else if( Sec_depuis_debut()<73 					// s'il reste plus de 17s
					&& Angle_Robot_Adverse()<176){					// et que le robot adverse n'est pas de son ct du conteneur (pas en zone 12)
					transition = 1;
					etat = 204;										// tenter de pousser les balles de l'adversaire
				}
				break;
			
			
			case 204 :
				poussee_ok = 0;
				Pivot_Gauche();
				transition = 1;
				etat = 2041;
				break;

			case 2041 :
				if( transition ){
					GotoXY_Propulsion(1300,Y_Propulsion(),80);
					transition=0;
				}else if( adv_devant>=2 ) {		// si notre adversaire est devant 
					Stop_Propulsion();
					transition = 1;
					etat = 2042;
				}else if( !ismoving ){
					transition = 1;
					etat = 205;
				}
				break;
			
			case 2042 :
				if( Sec_depuis_debut()>73 ){	// si on a moins de 17s
					transition = 1;
					etat = 207;					// abandonner
				} else if( adv_devant<2 ){		// si l'adversaire n'est plus devant
					transition = 1;
					etat = 2041;				// reprendre la manoeuvre
				}
				break;
	
			case 205 :
				Ejecteur_Gauche_Actif();
				Commande_Rouleaux(90, -120);
				transition = 1;
				etat = 206;
				break;

			case 206 :
				if( transition ){
					GotoXY_Propulsion(3000,Y_Propulsion(),80);
					transition=0;
				}else if( adv_devant>=2 ) { //|| propuls=='g' ){
					transition = 1;
					etat = 207;
				}else if( X_Propulsion()>2300 ){
					transition = 2;
					etat = 210;
				}
				break;

			case 207:
				if (adv_devant<2) {						// si l'adversaire n'est plus l
					transition = 1;
					etat = 206;							// reprendre la pousse
				} else if( Sec_depuis_debut()>73) {		// s'il reste - de 17s
					transition = 1;
					etat = 221;							// abandonner
				}
				break;

			case 210 :
				if( transition ){
					GotoXY_Propulsion(3000,Y_Propulsion()+10,15);
					transition=0;
				}else if( IO_Sw_Gauche() && IO_Sw_Droit() ){
					transition = 1;
					etat = 220;
				}else if( propuls=='g' ){
					transition = 1;
					etat = 211;
				}
				break;

			case 211 :
				Direct_Propulsion(-50, 50);
				Ejecteur_Gauche_Repos();
				Delay10KTCYx(255);					// attendre 1 sec
				Polaire_Propulsion( -30, 5 );
				Delay10KTCYx(255);					// attendre 1 sec
				transition = 1;
				etat = 220;
				break;

			case 220 :
				poussee_ok = 1;
				transition = 1;
				etat = 221;
				break;

			case 221 :
				Direct_Propulsion(-50, 50);
				Ejecteur_Gauche_Repos();
				Delay10KTCYx(255);
				Stop_Propulsion();
				transition = 1;
				etat = 222;

			case 222 :
				Polaire_Propulsion( -30, 5 );
				Delay10KTCYx(250);					// attendre 1 sec
				Commande_Rouleaux( -90, -90 );

				transition = 1;
				if( poussee_ok )					// si la pousse a fonctionn 
					etat = 224;						// ... dposer ici
				else 								// sinon
					etat = 223;						// ... aller dposer chez nous
				break;

			case 223 : // (chec de la pousse  cause de l'adversaire)
				if( transition ){
					GotoXY_Propulsion(500,1800,-80);				// revenir chez nous
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 224;	
				}
				break;

			case 224 :
				if( transition ){
					Angle_Propulsion (-PI/2,30);						// s'orienter vers le distri blanc
					transition=0;
				}else if( !ismoving ){
					transition = 1;
					etat = 225;	
				}
				break;

			case 225 :
				Recal_Arriere();
				transition = 1;
				etat = 230;
				break;
				

			case 230 :
				if( Sec_depuis_debut()>80 ){						// s'il reste moins de 10s
					transition = 1;
					etat = 1000;									// aller dposer
				}
				break;
			
			
			
			
			
			
			
			
			case 1000 : // (dpose)
				if( transition ){
					if (X_Propulsion()<=1500) 							// Si on est du ct bleu ...
						DeposeBalle_Chez_Nous_Barillet();				// ... on dpose chez nous
					else												// sinon ...
						DeposeBalle_Adverse_Barillet();					// ... on dpose chez l'adversaire
					transition = 0;
				}
				break;


				
					
			default: 				// dans le pire des cas, il vaut toujours mieux dposer
				etat = 1000;
				break;

		} // fin switch(etat)
	
	} // fin while(etat<254)
	
	
	print_str( "fin" );
}




// --------------------------------------------------------------------------
/* Permet de faire un pivot  droite
 *  Pas de paramtre
*/
void Pivot_Droite(void)
{
	Direct_Asservi_Propulsion (15,-5);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()>-2241);

	Direct_Asservi_Propulsion (10,-5);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()>-2841);

	Stop_Propulsion();
	while (Etat_Propulsion()!='a');

	Angle_Propulsion (PI,10);
	while(Etat_Propulsion()!='a');
}



// --------------------------------------------------------------------------
/* Permet de faire un pivot  gauche
 *  Pas de paramtre
*/
void Pivot_Gauche(void)
{
	Direct_Asservi_Propulsion (-5,15);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()<-900);

	Direct_Asservi_Propulsion (-5,10);					// Manoeuvre 1, ou tourne une roue
	while (A_Propulsion()<-300);

	Stop_Propulsion();
	while (Etat_Propulsion()!='a');

	Angle_Propulsion (0,10);
	while(Etat_Propulsion()!='a');
}





