// Fichier IO.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					des entres/sorties 				*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 * .Grandes modifications :                             *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <p18f452.h>		// Librairie du PIC utilis

#include "IO.h"





// --------------------------------------------------------------------------
/* Initialise les ports des entres numriques (Jack, switchs de recalage)
 *  Pas de paramtre
*/
void IO_Init (void)
{
	TRIS_JACK=1;				// Configure le jack en entre
	TRIS_SWITCH_GAUCHE=1;		// Configure le switch gauche en entre
	TRIS_SWITCH_DROIT=1;		// Configure le switch droit en entre
}




// --------------------------------------------------------------------------
/*	Retourne l'tat du Jack
 *  0 = pas de jack
 *  1 = jack enfon
*/
unsigned char IO_Jack (void)
{
	return (JACK);
}




// --------------------------------------------------------------------------
/*	Retourne l'tat du switch gauche
 *  0 = switch au repos
 *  1 = switch enfon
*/
unsigned char IO_Sw_Gauche (void)
{
	return (!SWITCH_GAUCHE);
}




// --------------------------------------------------------------------------
/*	Retourne l'tat du switch droit
 *  0 = switch au repos
 *  1 = switch enfon
*/
unsigned char IO_Sw_Droit (void)
{
	return (!SWITCH_DROIT);
}


