
#include <Delays.h>


#include "IO.h"					// Utilis pour les switchs
#include "Propulsion.h"			// Utilis pour les dplacements
#include "Telemetres.h"			// Utilis pour mesurer la distance du bord de la table
#include "Horloge.h"			// Pour les TimeOut
#include "Recal.h"				// Entte de la librairie
#include "Constante.h"			// Constantes
#include "Barillet.h"			// Pour le barillet
#include "Rouleaux.h"			// Pour les rouleaux
#include "mystdio.h"



// --------------------------------------------------------------------------
/* Recalage ct bleue
 * Le robot se place sur son aire de dpart et se recalle en X puis en Y 
 * On suppose que le robot se trouve approximativement en 2650,350 
 * A la fin du recalage, le robot se retrouve galement dans cette position
 * Arguments : 
 *  En_X=1 pour se recaler en X
 *	En_Y=1 pour se recaler en Y
 * 
 * Paramtre retourn : 
 *   Aucun

void Recal_Cote_Bleu (unsigned char En_X,unsigned char En_Y)
{
	int temps;
	
	// Recalage en X

	if (En_X)
	{
		Angle_Propulsion (0,40);									// S'oriente face  la largeur de la table
		while (	IsMove_Propulsion() );						
	
		if (Recal_Avant())
			Force_Propulsion(2766,Y_Propulsion(),0);				// Force la position du robot	
	}
	
	
	
	
	// Reviens au point de dpart
	
	if (En_X && En_Y)
	{
		GotoXY_Propulsion (2650,350,-40);							// Recule au point de recalage
		while (	IsMove_Propulsion() );				
	}
	
	
	
	// Recalage en Y
	
	if (En_Y)
	{
		Angle_Propulsion (-PI/2.0,40);								// S'oriente face  la longueur de la table
		while (	IsMove_Propulsion() );							
	
		if (Recal_Avant())
			Force_Propulsion(X_Propulsion(),234,-1571);				// Force la position du robot
		
		Stop_Propulsion();
		while (Etat_Propulsion ()!='a');
	}
}	
*/

// --------------------------------------------------------------------------
/* Recalage ct bleu
 * Le robot se place sur son aire de dpart et se recalle en X puis en Y 
 * On suppose que le robot se trouve approximativement en 2650,350 
 * A la fin du recalage, le robot se retrouve galement dans cette position
 * Arguments : 
 *  En_X=1 pour se recaler en X
 *	En_Y=1 pour se recaler en Y
 * 
 * Paramtre retourn : 
 *   Aucun
*/
void Recal_Cote_Bleu (unsigned char En_X,unsigned char En_Y)
{
	int temps;
	int Angle_Robot=A_Propulsion();
	
	if (En_X && En_Y)													// On doit faire les deux recallages
	{
		if (Angle_Robot<-785 || Angle_Robot>2356)						// On commence par le recallage en Y
		{
			// Recallage en Y
			
			Angle_Propulsion (-PI/2.0,40);								// S'oriente face  la longueur de la table
			while (	IsMove_Propulsion() );					
			if (Recal_Avant())											// Recallage
				Force_Propulsion(X_Propulsion(),234,-1571);			// Force la position du robot		
		
			// Reviens au centre

			GotoXY_Propulsion (2650,350,-40);							// Recule au point de recalage
			while (	IsMove_Propulsion() );

			// Recallage en X
			
			Angle_Propulsion (0,40);									// S'oriente face  la largeur de la table
			while (	IsMove_Propulsion() );							
			if (Recal_Avant())
				Force_Propulsion(2766,Y_Propulsion(),0);				// Force la position du robot	
				
			return;
		}
		else
		{
			
			// Recallage en X
			
			Angle_Propulsion (0,40);										// S'oriente face  la largeur de la table
			while (	IsMove_Propulsion() );							
			if (Recal_Avant())
				Force_Propulsion(2766,Y_Propulsion(),0);					// Force la position du robot	
				
			// Reviens au centre

			GotoXY_Propulsion (2650,350,-40);							// Recule au point de recalage
			while (	IsMove_Propulsion() );
	
			// Recallage en Y
			
			Angle_Propulsion (-PI/2.0,40);								// S'oriente face  la longueur de la table
			while (	IsMove_Propulsion() );					
			if (Recal_Avant())											// Recallage
				Force_Propulsion(X_Propulsion(),234,-1571);				// Force la position du robot		
			return;
		}
	}
	
	
	// Recalage en X

	if (En_X)
	{
		Angle_Propulsion (0,40);										// S'oriente face  la largeur de la table
		while (	IsMove_Propulsion() );							
		if (Recal_Avant())
			Force_Propulsion(2766,Y_Propulsion(),0);					// Force la position du robot	
		return;
	}
	
	// Recalage en Y
	
	if (En_Y)
	{
		Angle_Propulsion (-PI/2.0,40);								// S'oriente face  la longueur de la table
		while (	IsMove_Propulsion() );					
		if (Recal_Avant())											// Recallage
			Force_Propulsion(X_Propulsion(),234,-1571);				// Force la position du robot		
		return;
	}
}	








// --------------------------------------------------------------------------
/* Recalage ct rouge
 * Le robot se place sur son aire de dpart et se recalle en X puis en Y 
 * On suppose que le robot se trouve approximativement en 350,350 
 * A la fin du recalage, le robot se retrouve galement dans cette position
 * Arguments : 
 *  En_X=1 pour se recaler en X
 *	En_Y=1 pour se recaler en Y
 * 
 * Paramtre retourn : 
 *   Aucun
*/
void Recal_Cote_Rouge (unsigned char En_X,unsigned char En_Y)
{
	int temps;
	int Angle_Robot=A_Propulsion();
	
	if (En_X && En_Y)													// On doit faire les deux recallages
	{
		if (Angle_Robot<795 && Angle_Robot>-2356)						// On commence par le recallage en Y
		{
			// Recallage en Y
			
			Angle_Propulsion (-PI/2.0,40);								// S'oriente face  la longueur de la table
			while (	IsMove_Propulsion() );					
			if (Recal_Avant())											// Recallage
				Force_Propulsion(X_Propulsion(),234,-1571);				// Force la position du robot		
		
			// Reviens au centre

			GotoXY_Propulsion (350,350,-40);							// Recule au point de recalage
			while (	IsMove_Propulsion() );

			// Recallage en X
			
			Angle_Propulsion (PI,40);										// S'oriente face  la largeur de la table
			while (	IsMove_Propulsion() );							
			if (Recal_Avant())
				Force_Propulsion(234,Y_Propulsion(),3141);					// Force la position du robot	
				
			return;
		}
		else
		{
			
			// Recallage en X
			
			Angle_Propulsion (PI,40);										// S'oriente face  la largeur de la table
			while (	IsMove_Propulsion() );							
			if (Recal_Avant())
				Force_Propulsion(234,Y_Propulsion(),3141);					// Force la position du robot	
				
			// Reviens au centre

			GotoXY_Propulsion (350,350,-40);							// Recule au point de recalage
			while (	IsMove_Propulsion() );
	
			// Recallage en Y
			
			Angle_Propulsion (-PI/2.0,40);								// S'oriente face  la longueur de la table
			while (	IsMove_Propulsion() );					
			if (Recal_Avant())											// Recallage
				Force_Propulsion(X_Propulsion(),234,-1571);				// Force la position du robot		
			return;
		}
	}
	
	
	// Recalage en X

	if (En_X)
	{
		Angle_Propulsion (PI,40);										// S'oriente face  la largeur de la table
		while (	IsMove_Propulsion() );							
		if (Recal_Avant())
			Force_Propulsion(234,Y_Propulsion(),3141);					// Force la position du robot	
		return;
	}
	
	// Recalage en Y
	
	if (En_Y)
	{
		Angle_Propulsion (-PI/2.0,40);								// S'oriente face  la longueur de la table
		while (	IsMove_Propulsion() );							
	
		if (Recal_Avant())
			Force_Propulsion(X_Propulsion(),234,-1571);				// Force la position du robot
	}
}	







//-----------------------------------------------------------------------
/* Le robot se recal sur un bord avec les switchs en avant
 * Le robot doit tre prs d'un bord
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *  0 : le recallage est un chec
 *  1 : le recallage est russit
*/
unsigned char Recal_Avant(void)
{	int ret;
	
	int temps=Cent_depuis_debut ();										// Mesure l'heure au dbut de la fonction
	Stop_Propulsion();
	while (Etat_Propulsion()!='a');
	
	//print_str ("Recule rapide\n");	
	ToutDroit_Propulsion (1000,VIT_CALAGE_RAPIDE);					// Avance rapidement vers le bord
	do 
		Delay10KTCYx(1);		
	while (!IO_Sw_Gauche() && !IO_Sw_Droit() && 					// Jusqu' ce que l'on ai un des deux switchs
			Telemetre_Bleu()+Telemetre_Rouge()<SEUIL_RECAL &&		// ... ou que le robot soit prs du bord ...
			IsMove_Propulsion() &&									// ... le mouvement est termin ou le robot est bloqu ...
			Cent_depuis_debut()-temps<TIMEOUT_CALAGE &&				// ... ou le time out est atteint ...
			NbBalles_Barillet(TOUTES)!=5 &&							// ... ou que l'on a 5 balles (le capteur est masqu)
			!Barillet_Avale());										// ... ou que l'on ai chopp une balle
	
	temps=Cent_depuis_debut ();
	//print_str ("Recule lent\n");	

	Stop_Propulsion();
	while (Etat_Propulsion()!='a');	
	
	ret=ToutDroit_Propulsion (500,VIT_CALAGE_LENTE);						// On avance lentement
	Delay10KTCYx(100);
	while (!IO_Sw_Gauche() && !IO_Sw_Droit() && 						// Jusqu' ce que l'on ai un switch
			IsMove_Propulsion() &&										// ... le mouvement est termin ou le robot est bloqu ...
			Cent_depuis_debut()-temps<TIMEOUT_CALAGE){					// ... ou le time out est atteint
		Delay10KTCYx(1);
	}
	
	
	//print_strint("toutdroit=", ret, 1);
	//print_strint("stop=", Stop_Propulsion(), 1);
	Stop_Propulsion();
	while (Etat_Propulsion()!='a');	

	//print_str ("Switch\n");
			
	while ( !IO_Sw_Gauche() || !IO_Sw_Droit()) 							// Tant qu'on a pas les deux switchs...			
	{
		if (!IO_Sw_Gauche() && !IO_Sw_Droit())							// Si on a aucun des deux
//			Polaire_Propulsion (15,0);
			Direct_Propulsion(300,300);
			
		else if (!IO_Sw_Gauche())										// Si pas switch gauche
//			Polaire_Propulsion (5,-20);
			Direct_Propulsion(400,-250);
						
		else if (!IO_Sw_Droit() )										// Si pas switch droit
//			Polaire_Propulsion (5,20);
			Direct_Propulsion(-250,400);
			
		if (Cent_depuis_debut()-temps>TIMEOUT_CALAGE)					// Si le time out est atteint
		{
			print_str ("Time Out\n");
			Stop_Propulsion();											// On abandonne
			return 0;													// On retourne 0 pour indiquer qu'on est pas recaller
		}	
		
		Delay10KTCYx(1);			
	}
	
	
	Direct_Propulsion (400,400);										// Force sur le bord pour tre sur du recallage
	Delay10KTCYx(100);
	Stop_Propulsion();													// On est recall, 
	return 1;															// C'est super, on retourne 1
}	








//-----------------------------------------------------------------------
/* Le robot se recal sur un bord avec les switchs
 * Le robot doit tre prs d'un bord
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *  0 : le recallage est un chec
 *  1 : le recallage est russit
*/
unsigned char Recal_Arriere(void)
{	int ret;
	int temps=Cent_depuis_debut ();										// Mesure l'heure au dbut de la fonction
	Stop_Propulsion();
	while (Etat_Propulsion()!='a');

	//print_str ("Recule rapide\n");
	ToutDroit_Propulsion (1000,-VIT_CALAGE_RAPIDE);						// Avance rapidement vers le bord
	do 
		Delay10KTCYx(1);		
	while ( !IO_Sw_Gauche() && !IO_Sw_Droit() &&						// Jusqu' ce que l'on ai au moins un des deux switch ...
			Y_Propulsion()<1850 && 										// ... ou que le robot soit prs du bord ...
			IsMove_Propulsion() &&										// ... le mouvement est termin ou le robot est bloqu ...
			Cent_depuis_debut()-temps<TIMEOUT_CALAGE);					// ... ou le time out est atteint
	
	Stop_Propulsion();
	while (Etat_Propulsion()!='a');

	temps=Cent_depuis_debut ();											
	//print_str ("Recule lent\n");
	
	ret=ToutDroit_Propulsion (500,-VIT_CALAGE_LENTE);						// On recule lentement
	Delay10KTCYx(100);
	while (!IO_Sw_Gauche() && !IO_Sw_Droit() && 						// Jusqu' ce que l'on ai un switch
			IsMove_Propulsion() &&										// ... le mouvement est termin ou le robot est bloqu ...
			Cent_depuis_debut()-temps<TIMEOUT_CALAGE){					// ... ou le time out est atteint
	
			Delay10KTCYx(1);
		//if( Cent_depuis_debut()%10==0 )
			//print_strint("cs=", Cent_depuis_debut(),0);
		
	}
	//print_str("avant stop\n");
	//print_strint("toutdroit=", ret, 1);
	//print_strint("stop=", Stop_Propulsion(), 1);
	Stop_Propulsion();
	while (Etat_Propulsion()!='a');

	//print_str ("Switch\n");
	while ( !IO_Sw_Gauche() || !IO_Sw_Droit()) 							// Tant qu'on a pas les deux switchs...			
	{
		if (!IO_Sw_Gauche() && !IO_Sw_Droit())							// Si on a aucun des deux			
//			Polaire_Propulsion (-15,0);
			Direct_Propulsion(-300,-300);
			
		else if (!IO_Sw_Gauche())										// Si pas switch gauche			
//			Polaire_Propulsion (-5,20);
			Direct_Propulsion(-400,250);						
			
		else if (!IO_Sw_Droit() )										// Si pas switch droit			
//			Polaire_Propulsion (-5,-20);
			Direct_Propulsion(250,-400);
			
		if (Cent_depuis_debut()-temps>TIMEOUT_CALAGE)					// Si le time out est atteint
		{
			print_str ("Time Out\n");
			Stop_Propulsion();											// On abandonne
			return(0);													// On retourne 0 pour indiquer qu'on est pas recaller
		}	
		Delay10KTCYx(1);			
	}
		
	//Polaire_Propulsion (-15,0);											// Force sur le bord pour tre sur du recallage
	Direct_Propulsion (-400,-400);										// Force sur le bord pour tre sur du recallage
	Delay10KTCYx(100);
	Stop_Propulsion();													// On est recall, 
	//print_str ("Recal OK\n");	
	return 1;															// C'est super, on retourne 1
}	

