

// Fichier Depart_Bleue.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *			Recharge le barillet cot Bleue				*
 *                                                      *
 * .Date de cration : 23/04/08                         *
 * .Auteur : Jrmie LUMINEAU							*       
 *                                                      *
 * .Descriptions :                                      *
 *      - code du rechargement du barillet							*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <delays.h>
#include "mystdio.h"


#include "strategie_bleu.h"
#include "Recharge_barillet_bleu.h"
#include "lcd.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "IO.h"
#include "I2C_Master.h"
#include "barillet.h"
#include "Horloge.h"
#include "led.h"
#include "Telemetres.h"
#include "serial.h"
#include "canon.h"
#include "Tourelle.h"
#include "Recal.h"
#include "Distributeur.h"
#include "Constante.h"







// --------------------------------------------------------------------------
/* 
 * Rammasse les deux premires balles bleues sur la table
 * Prends 3 balles au distributeur blanc
 * Fait le complment de bleues si ncessaire
 * Va tout dposer dans le conteneur standard
*/
void Rechargement_Barillet_Bleu ( void )
{
	
	
	
	
	unsigned char	etat=0;										// Etat courant de la machine principale
	unsigned char   Etat_Rouleaux=0;							// Etat courant de la machine  tat pour les rouleaux
	
	char 			ismoving=0;
	char			transition=0;
	char			adv_devant=0;
	char			adv_derriere=0;
	float 			Beta;
	int				X;
	int 			ret;
	int 			NbEvit=0;									// nombre d'vitements 
	char 			flag=0;
	int 			nbballes;
	
	
	while( etat!=255 ){
		if( transition )
			print_strint( ">RECH Bar=", etat, 1 );
			
		// mise  jour des nouvelles conditions de transition :
		ismoving = IsMove_Propulsion();
			
		adv_devant=Adversaire_Devant();					// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
		adv_derriere=Adversaire_Derriere();				// Mesure si le robot adverse se trouve potentiellement sur la trajectoire
		
		if( transition && etat!=13 )					// Ne pas arrter les moteurs entre les changements d'angles
		{
			Stop_Propulsion();
			while (Etat_Propulsion()!='a');
		}

	
		
		
				
		nbballes = NbBalles_Barillet(TOUTES);
		if( nbballes==5 )								// si on a 5 balles,
			Commande_Rouleaux(-60, -60);				// inverser le sens des rouleaux
			
		if( nbballes==5 || (NbEvit>=3 && nbballes!=0) )	// quitter si 5 balles ou si trop d'vitements et au moins 1 balle
			etat = 255;
		
		Delay100TCYx(1);										// Attente entre deux cycles	
	
		switch (etat){
			
			case 0 :
				Beta=Angle_Robot_Adverse();
				X=X_Propulsion();
				//print_strint("beta=", Beta, 1 );
				//print_strint("x=", X, 1 );
				
				if (Beta<(175-0.032*X) || Nb_Balles_Distributeur_Blanc_Rouge==0 ){
					print_str( "->chez nous\n" );
					etat = 3;		// aller chez nous
				}
				else{
					print_str( "->chez adv\n" );
					etat = 1;		// aller chez l'adv
				}
				transition = 1;
				break;
					
			case 1 : 
				if (transition){
					GotoXY_Propulsion(500,750,100);
					transition = 0;
				}
				else if(adv_devant>=2){
					transition=1;
					etat=5;
				}
				else if( !ismoving ){
					if (Etat_Propulsion()=='g')
					{
						transition = 1;
						etat = 5;	
					}
					else
					{
						transition = 1;
						etat = 10;	
					}
				}
				break;
				
			case 2 :
				NbEvit++;
				Evite_Robot_Adverse(NbEvit);
				transition = 1;
				etat = 3;
				break;
				
			case 3 :
				if(transition){
					GotoXY_Propulsion(2600,400,100);
					transition = 0;
				}
				else if(Adversaire_Devant()>=2 ||
						Etat_Propulsion()=='g'){
					if( X_Propulsion()>2000){
						if( flag ){
							transition = 1;
							etat = 100;
						}else if( Nb_Balles_Distributeur_Blanc_Rouge!=0 ){
							transition = 1;
							etat = 150;
						}
						else {
							transition = 1;
							etat = 2;						
						}
					}
					else{
						transition = 1;
						etat = 2;
					}
				}
				else if(Etat_Propulsion()=='a')
				{
					transition = 1;
					etat = 4;	
				}				
				break;
				
			case 4 :

				ret = Complement_Bleu(5,0);
				transition = 1;
				etat = 255;
				break;
			
			case 5 :
				Delay10KTCYx(DELAY500ms);
				transition=1;
				etat = 12;
				break;
				
			case 10 :
				if(transition){
					Angle_Propulsion(PI,30);
					transition = 0;
				}
				else if( !ismoving ){
					transition = 1;
					etat = 11;
				}
				break;
			
			case 11 :
				Distributeur_Blanc_Rouge(5,1);
				flag = 1;
				transition = 1;
				etat = 12;
				break;
			
			case 12 :
				if(transition){
					GotoXY_Propulsion(2600,400,-80);
					transition = 0;
				}
				else if(Adversaire_Derriere()>=2){
					transition = 1;
					etat = 14;
				}
				else if( !ismoving ){
					if (Etat_Propulsion()=='g')
					{
						transition = 1;
						etat = 14;	
					}
					else
					{
						transition = 1;
						etat = 13;	
					}
				}
				break;					
			
			case 13 :
				if(transition){
					Angle_Propulsion(-PI/2, 40);
					transition = 0;
				}else if( !ismoving || A_Propulsion()<-3041 ){
					transition = 1;
					etat = 4;	
				}
				break;					
			
			case 14 :				
				NbEvit++;
				Evite_Robot_Adverse (NbEvit);
				transition=1;
				etat = 3;
				break;
			
			case 100 :
				if(transition){
					GotoXY_Propulsion(1800,400,-60);
					transition = 0;
				}
				else if( !ismoving ){
					transition = 1;
					etat = 101;
				}
				break;
			
			case 101 :
				if(transition){
					Angle_Propulsion(-PI/2.000,30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=102;
				}
				break;
			
			case 102 :
				Recal_Avant();
				transition=1;
				etat = 103;
				break;
			
			case 103 :
				if(transition){
					GotoXY_Propulsion(1800, 400,-30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=104;
				}
				break;
			
			case 104 :
				if(transition){
					Angle_Propulsion(PI,30);
					transition=0;
				}
				else if (!ismoving){
					transition=1;
					etat=105;
				}
				break;
			
			case 105 :
				if(transition){
					GotoXY_Propulsion(2200, 400,-40);
					transition=0;
				}
				else if( Etat_Propulsion()=='a' ){
					transition=1;
					etat=106;
				}
				break;
			
			case 106 :
				if(transition){
					Angle_Propulsion(-PI/2, 30);
					transition=0;
				}
				else if( !ismoving ){
					transition=1;
					etat=107;
				}
				break;
			
			case 107 :
				OrienteMax_Telemetre(10);
				transition=1;
				etat=108;
				break;
			
			case 108 :
				Distributeur_Bleu(5,1);
				transition = 1;
				etat = 255;
				break;
			
			
			case 150 :
				Delay10KTCYx(DELAY500ms);
				transition=1;
				etat = 151;
				break;
			
			case 151 :
				if (transition){
					GotoXY_Propulsion(500,750,-80);
					transition = 0;
				}
				else if(adv_derriere>=2 || Etat_Propulsion()=='g'){
					transition=1;
					etat=5;
				}
				else if(Etat_Propulsion()=='a')
				{
					transition = 1;
					etat = 152;	
				}
				break;
			
			case 152 :
				if(transition){
					Angle_Propulsion( PI, 30 );
					transition=0;
				}
				else if( !ismoving ){
					transition=1;
					etat=153;
				}
				break;
			
			case 153 :
				OrienteMax_Telemetre(10);
				transition=1;
				etat=11;
				break;
			
			
			default : // pas normal : quitter
				etat = 255;
	
		} // fin switch()
		
	} //fin while(etat!=255)
}	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
