// Fichier StartUp.h
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                Code source de la librairie           *
 *					de la carte principale 				*
 *                                                      *
 * .Date de cration : 27/01/08                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la carte principale   *
 *                                                      *
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/



#define MESSAGE_ACCUEIL					"::: Iron Maid v2 :::"	// Message d'acceuil au dmarrage du robot


#define CHECK_UP_SEUIL_18V				18.0					// Seuil pour la batterie puissance
#define CHECK_UP_SEUIL_12V				12.0					// Seuil pour la batterie logique

#define	TENSION_18


// --------------------------------------------------------------------------
/* Initialise tous les priphriques du robot
 *  - la led rouge
 *  - L'cran LCD
 *  - Les convertisseurs Analogiques/Numriques
 *  - Les entres sorties (Switch G/D & Jack)
 *  - La liaison srie
 *  - Le module I2C 
*/

void Init_Peripheriques(void);




// --------------------------------------------------------------------------
/* Scanne tous les priphriques et vrifie leur fonctionnement
 *  - la fonction retourne la couleur joue
 *  - Teste le fonctionnement des rouleaux dans les deux sens de rotation 
 * La fonction reoit la couleur joue (pour l'initialisation du barillet)
 *  
 * La fonction retourne 1 si le robot adverse est potentiellement dangeureux
 * La fonction retourne 0 si le robot adverse ne prsente pas de dangers pour nos balles
*/
unsigned char Check_Up (unsigned char CouleurJoue);





// --------------------------------------------------------------------------
/* Effectue un chek-up du rouleau droit
 * Lance le rouleau en avant et vrifie la vitesse   (erreurs 1 et 2)
 * Arrte le moteur et vrifie qu'il est  l'arrt   (erreurs 3 et 4)
 * Lance le rouleau en arrire et vrifie la vitesse (erreurs 5 et 6)
 * Pas de problme : on retourne 0 
*/
unsigned char Check_Up_Rouleau_Droit (void);






void Error_Blink (unsigned char);
