// Fichier Strategie.H
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                En-tte de la librairie           	*
 *					dfense 							*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la straegie   		*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/
#ifndef __DEFENSE_H__
#define __DEFENSE_H__


#include "lcd.h"
#include "StartUp.h"
#include "JoyStick.h"
#include "Propulsion.h"
#include "rouleaux.h"
#include "IO.h"
#include "I2C_Master.h"
#include "barillet.h"
#include "Horloge.h"
#include "led.h"
#include "Telemetres.h"
#include "serial.h"
#include "canon.h"
#include "Tourelle.h"



#define CBLEU	1
#define	CROUGE	-1

#define		DISTANCE_CONTACT			90				// Mesure du capteur au dela de laquelle on considre qu'il y a contact
#define		VIT_EVIT					50				// Vitesse lors de la manoeuvre d'vitement d'obstacle

#define		Y_DISTRI_BLANC_BLEU			750				// Position en Y du barillet blanc


#define		VIT_LENTE					80				// Vitesse de dplacement lente
#define		VIT_RAPIDE					100				// Vitesse de dplacement rapide



//-----------------------------------------------------------------------
/* Le robot se place en dfense de notre ct en protgeant les balles
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *	 aucun
 */
void Defense_Bleue(void);


/* EnleverBalles : permet d'enlever les balles adverses de sa partie de conteneur
	prrequis : on a  peu prs le distributeur dans le dos (angle robot = -pi/2)
	et qu'on en n'est pas trop loin (quelques centimtres).
	Arguments :
		couleur : la couleur DU ROBOT ADVERSE (1 pour bleu, -1 pour rouge)
	Valeur renvoye :
		0 si a s'est bien pass
		-1 si on a t bloqu et qu'on a d abandonner la manoeuvre
 */  
int EnleverBalles(char couleur );	

/* PousserBalles : permet de pousser vers chez nous les balles adverses 
	prrequis : on a  peu prs le distributeur dans le dos (angle robot = -pi/2)
	et qu'on en n'est pas trop loin (quelques centimtres).
	Arguments :
		couleur : la couleur DU ROBOT ADVERSE (1 pour bleu, -1 pour rouge)
		enlever : 1 pour enlever, 0 pour pousser vers chez nous
	Valeur renvoye :
		0 si a s'est bien pass
		-1 si on a t bloqu et qu'on a d abandonner la manoeuvre
 */  
int PousserBalles( char couleur );



#endif
