// Fichier Strategie.c
/////////////////////////////////////////////////////////

/********************************************************
 *                                                      *
 *                source de la librairie             	*
 *					strategie							*
 *                                                      *
 * .Date de cration : 29/12/07                         *
 * .Auteur : Philippe Lucidarme                         *       
 *                                                      *
 * .Descriptions :                                      *
 *      - code des fonctions pour la straegie   		*
 *                                                      *
 *                                                      *
 * .Remarques :                                         *
 *                                                      *
 ********************************************************/

#include <delays.h>
#include "mystdio.h"
#include "Constante.h"

#include "strategie_bleu.h"


volatile unsigned char 		Nb_Depose_Adverse=0;										// Nombre de dposes chez l'dversaire


// --------------------------------------------------------------------------
/* Retourne du ct bleu align sur les deux distributeurs
 * Normalement on vite le robot adverse. Au bout de trois fois, 
 * on passe en force
 * Arguments : 
 *   Aucun
 * 
 * Paramtre retourn : 
 *   Aucun

unsigned char Goto_Cote_Rouge (void)
{
	char	NbEvitements=0;										// Nombre d'vitements du robot adverse		
	float 	Angle_Adverse;										// Angle avec le robot adverse en radian
	float 	Angle_Robot;										// Orientation du robot avant la dtection de l'adversaire
	
	
	GotoXY_Propulsion(700,750,VIT_RAPIDE);						// Se dplace jusqu'au point demand en marche avant
	while (Etat_Propulsion ()!='a')
	{
//		Delay10KTCYx(1);										// Tempo pour viter les lectures trop rapides
		
		
		if (Etat_Propulsion()=='g')								// Si le robot est bloqu
		{
			Stop_Propulsion();
			Delay10KTCYx(200);

			ToutDroit_Propulsion(150,-40);						// On recule
			while ( Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g');
			Evite_Robot_Adverse(1);								// Routine d'vitement du robot adverse
				NbEvitements++;
			if (NbEvitements>=4)											// Aprs 3 vitements et un forage, on est pas pass : tant pis :
			{
				Stop_Propulsion();
				while (Etat_Propulsion()!='a');
			}
			else
				GotoXY_Propulsion(700,750,VIT_RAPIDE);					// Se dplace jusqu'au point demand en marche avant
		}
		
		
		if 	((Angle_Robot_Adverse()>96  && 						// Si le robot est potentiellement sur la trajectoire
			Angle_Robot_Adverse()<159) ||
			Distance_Robot_Adverse()==0)						// On si on ne le voit pas !
										
		{		
			if 	((Telemetre_Avant_Droit()>DISTANCE_OBSTACLE ||	// On teste les capteurs  droite ...
				Telemetre_Avant_Gauche()>DISTANCE_OBSTACLE)	&&	// ... et  gauche
				(NbEvitements<3))								// On ne l'a pas vit 3 fois
			{
				Stop_Propulsion();								// On arrte le robot
				while (	Etat_Propulsion ()!='a');				// On attends d'tre compltement stopp
				Evite_Robot_Adverse(1);							// Routine d'vitement du robot adverse
				NbEvitements++;
				GotoXY_Propulsion(700,750,VIT_RAPIDE);			// Se dplace jusqu'au point demand en marche avant
			}
		}
		
	}
	Stop_Propulsion();											// Manifestement, on est arriv !
	return NbEvitements;
}

*/





// --------------------------------------------------------------------------
/* Retourne du ct bleu align sur les deux distributeurs en marche arrire
 * Normalement on vite le robot adverse. Au bout de trois fois, 
 * on passe en force
 * Arguments : 
 *   Aucun
 * 
 * Paramtre retourn : 
 *   Aucun

unsigned char Goto_Cote_Rouge_Arriere (void)
{
	char	NbEvitements=0;										// Nombre d'vitements du robot adverse		
	float 	Angle_Adverse;										// Angle avec le robot adverse en radian
	float 	Angle_Robot;										// Orientation du robot avant la dtection de l'adversaire
	
	print_str("Gto Rouge Arr\n");
	GotoXY_Propulsion(700,750,-VIT_LENTE);						// Se dplace jusqu'au point demand en marche arrire
	while (Etat_Propulsion ()!='a')
	{
		
		if (Etat_Propulsion()=='g')								// Si le robot est bloqu
		{
			Stop_Propulsion();
			Delay10KTCYx(200);
			ToutDroit_Propulsion(150,40);						// On avance
			while ( Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g');
			Evite_Robot_Adverse(1);								// Routine d'vitement du robot adverse
				NbEvitements++;
			if (NbEvitements>=4)								// Aprs 3 vitements et un forage, on est pas pass : tant pis :
			{
				Stop_Propulsion();
				while (Etat_Propulsion()!='a');
			}
			else		
				GotoXY_Propulsion(700,750,-VIT_LENTE);			// Se dplace jusqu'au point demand en marche avant
		}
				
		
		if 	(Angle_Robot_Adverse()<32  || 						// Si le robot est potentiellement sur la trajectoire
			Angle_Robot_Adverse()>223 ||
			Distance_Robot_Adverse()==0)						// On si on ne le voit pas !
										
		{		
			if 	(Telemetre_Arriere()>90 &&						// On teste les capteurs arrire			
				NbEvitements<3)									// On ne l'a pas vit 3 fois
			{
				Stop_Propulsion();								// On arrte le robot
				while (	Etat_Propulsion ()!='a');				// On attends d'tre compltement stopp
				Evite_Robot_Adverse(1);							// Routine d'vitement du robot adverse
				NbEvitements++;
				GotoXY_Propulsion(700,750,-VIT_LENTE);			// Se dplace jusqu'au point demand en marche arrire
			}
		}
		else
		{
			GotoXY_Propulsion(800,750,-VIT_RAPIDE);			// Se dplace jusqu'au point demand en marche arrire  fond
			while ( Angle_Robot_Adverse()>=32  &&				// Jusqu' ce que le robot revienne sur la trajectoire ...
					Angle_Robot_Adverse()<=223 &&		
					Distance_Robot_Adverse()!=0 &&				// ... ou si on ne le voit plus ... 
					Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g');					// ... ou qu'on est arriv ...
			if (Etat_Propulsion()!='a')							// Si on est pas arriv ...
				GotoXY_Propulsion(700,750,-VIT_LENTE);			// ... on ralentit !
		}		
	}
	Stop_Propulsion();											// Manifestement, on est arriv !
	return NbEvitements;
}

*/ 



// --------------------------------------------------------------------------
/* Va se placer contre le conteneur standard en marche arrire.
 * Normalement on vite le robot adverse. Au bout de trois fois, 
 * on passe en force
 * Arguments : 
 *  - La position en X du point de dpose 
 * 
 * Paramtre retourn : 
 *   Le nombre de fois qu'on a vit l'adversaire
*/
/*unsigned char Goto_Conteneur (int X)
{
	char	NbEvitements=0;													// Nombre d'vitements du robot adverse		
	float 	Angle_Adverse;													// Angle avec le robot adverse en radian
	float 	Angle_Robot;													// Orientation du robot avant la dtection de l'adversaire
	
	int 	XTarget,YTarget;												// Points de passage intermdaire
	long int Distance_Cible;												// Distance entre le robot et la cible
	long int Xrobot,Yrobot;													// Coordonnes du robot

//	Stop_Propulsion();														// Stopppe les moteurs 
//	Delay10KTCYx(50);


	// ------------------------------------------------------------------
	// Phase 0 : Localisation de l'adversaire et cration de la trajectoire
	//
	
	XTarget=X;																// Position de la cible
	YTarget=Y_CONTENEUR;
	
	
	
	// ------------------------------------------------------------------
	// Phase 1 : Dplacement
	//
	
	GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);							// Se dplace jusqu'au point demand en marche arrire
	while (Etat_Propulsion ()!='a')											// Tant qu'on est pas arriv
	{	
	
		if (Etat_Propulsion()=='g')											// Si le robot est bloqu
		{
			Stop_Propulsion();												// On stoppe les moteurs
			print_str("Evitement blocage\n");								// On informe l'utilisateur
			ToutDroit_Propulsion(150,40);									// On avance
			while ( Etat_Propulsion()!='a' &&							
					Etat_Propulsion()!='g');
			Evite_Robot_Adverse();											// Routine d'vitement du robot adverse
			NbEvitements++;	
			if (NbEvitements>=4)											// Aprs 3 vitements et un forage, on est pas pass : tant pis :
			{
				Stop_Propulsion();
				while (Etat_Propulsion()!='a');
			}
			else
				GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);				// Se dplace jusqu'au point demand en marche avant
		}
		
		
		
		if 	(Angle_Robot_Adverse()<32  || 									// Si le robot est potentiellement sur la trajectoire
			Angle_Robot_Adverse()>223 ||
			Distance_Robot_Adverse()==0)									// On si on ne le voit pas !
										
		{	
		
			if 	((Telemetre_Arriere_Droit()>DISTANCE_OBSTACLE ||			// On teste les capteurs  droite ...
				Telemetre_Arriere_Gauche()>DISTANCE_OBSTACLE)	&&			// ... et  gauche
				(NbEvitements<3))											// On ne l'a pas vit 3 fois
			{
				
				Stop_Propulsion();											// On arrte le robot
				
				Xrobot=X_Propulsion();										// On lit la position du robot
				Yrobot=Y_Propulsion();
				
				Distance_Cible=(X-Xrobot)*(X-Xrobot)+(Y_CONTENEUR-Yrobot)*(Y_CONTENEUR-Yrobot);	// Calcule la distance entre le robot et la cible
				
				
				if (Distance_Cible<250000)									// On fait un vitement trop proche de la cible, on switch de cible
				{
					print_str("Switch target\n");
					Delay10KTCYx(200);										// On attends pour ne pas faire du wheeling
					GotoXY_Propulsion(600,Y_CONTENEUR,100);					// On change de position: on va chez lui
					Nb_Depose_Adverse++;									// On incrmente le nombre de dposes chez l'adversaire
					while (Etat_Propulsion()!='a' &&						// On attends la fin de la manoeuvre
							Etat_Propulsion()!='g');
					Stop_Propulsion();										// On arrte les moteurs
					while (Etat_Propulsion()!='a');							// Du coup, on doit aussi quitter la boucle principale
				}
				else
				{
					print_str("Evitement capteurs\n");					
					while (	Etat_Propulsion ()!='a');							// On attends d'tre compltement stopp				
					Evite_Robot_Adverse();										// Routine d'vitement du robot adverse
					NbEvitements++;
					GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);					// Se dplace jusqu'au point demand en marche arrire
				}
			}
		}
		else
		{
			GotoXY_Propulsion(XTarget,YTarget,-VIT_RAPIDE);					// Se dplace jusqu'au point demand en marche arrire  fond
			while ( Angle_Robot_Adverse()>=32  &&							// Jusqu' ce que le robot revienne sur la trajectoire ...
					Angle_Robot_Adverse()<=223 &&		
					Distance_Robot_Adverse()!=0 &&							// ... ou si on ne le voit plus ... 
					Etat_Propulsion()!='a' &&
					Etat_Propulsion()!='g');								// ... ou qu'on est arriv ...
					
			if (Etat_Propulsion()!='a')										// Si on est pas arriv ...
				GotoXY_Propulsion(XTarget,YTarget,-VIT_LENTE);				// ... on ralentit !
		}		
	}
	Stop_Propulsion();														// Coupe les moteurs
	while (Etat_Propulsion ()!='a');										// Laisse le temps  la carte de s'arrter
	
	
	
	
	// ------------------------------------------------------------------
	// Phase 2 : Orientation et attends que le chemin soit libre
	//
	
	Angle_Propulsion (-PI/2.0,40);											// S'oriente vers le conteneur
	while (Etat_Propulsion ()!='a');

	NbEvitements=0;
	while ((Telemetre_Arriere_Droit()>DISTANCE_OBSTACLE ||					// On regarde s'il y a un robot derrire nous
			Telemetre_Arriere_Gauche()>DISTANCE_OBSTACLE) && 
			NbEvitements<50)
	{
		NbEvitements++;														// On incrmente le nombre d'vitements
		Delay10KTCYx(20);													// On attends un peu
		Angle_Propulsion (-PI/2.0,20);										// Se roriente vers le conteneur (au cas ou l'adversaire nous aurait touch)
		while (Etat_Propulsion ()!='a');
	}		
	


	// ------------------------------------------------------------------
	// Phase 3 : Callage
	//
	
	ToutDroit_Propulsion (700, -50);										// On recule rapidement
	while (	Y_Propulsion ()<1800 &&											// Soit on est tout pret de la bordure				
			Etat_Propulsion ()!='a' &&										// Soit on est arriv ???
			Etat_Propulsion ()!='g');										// Soit on est bloqu
						
	NbEvitements=0;
	
	
	ToutDroit_Propulsion (1500, -20);										// On recule gentiment pour se caller
	while (! (IO_Sw_Gauche () && IO_Sw_Droit ()) && NbEvitements<4)			// Jusqu' ce qu'on est les deux switchs
	{
		if (Etat_Propulsion ()=='g')										// Si le robot est bloqu (on a coinc l'adversaire ?)
		{
			ToutDroit_Propulsion (350, 50);									// On avance de 35 cm
			while (	Etat_Propulsion ()!='g' &&								// Jusqu' ce que l'on soit de nouveau bloqu ...
					Etat_Propulsion ()!='a');								// ... ou arriv
			Delay10KTCYx(255);												// On attends pour que le robot adverse puisse se faire la malle
			NbEvitements++;
			if (NbEvitements==2)
			{
				if ( Distance_Robot_Adverse()==0 ||
					 Angle_Absolu_Robot_Adverse()>PI/2.0 ||
					 Angle_Absolu_Robot_Adverse()<-PI/2.0)
					 GotoXY_Propulsion(X_CONTENEUR_SECOURS,Y_CONTENEUR,50);						// On change de position 
				else
					GotoXY_Propulsion(600,Y_CONTENEUR,80);						// On change de position 
				while (	Etat_Propulsion ()!='g' &&							// Jusqu' ce que l'on soit de nouveau bloqu ...
				Etat_Propulsion ()!='a');									// ... ou arriv
				
				Angle_Propulsion (-PI/2.0,30);								// Se roriente vers le conteneur (au cas ou l'adversaire nous aurait touch)
				while (	Etat_Propulsion ()!='g' &&							// Jusqu' ce que l'on soit de nouveau bloqu ...
				Etat_Propulsion ()!='a');									// ... ou arriv			
				ToutDroit_Propulsion (1500, -50);							// On recule  nouveau	
				while (	Y_Propulsion ()<1800 &&											// Soit on est tout pret de la bordure				
					Etat_Propulsion ()!='a' &&										// Soit on est arriv ???
					Etat_Propulsion ()!='g');										// Soit on est bloqu
									
			}
			ToutDroit_Propulsion (1500, -20);								// On recule gentiment pour se caller
		}
	}
	Delay10KTCYx(1);

																			// On attends un poil pour que le robot soit bien coll sur le bord
	if (IO_Sw_Gauche () && IO_Sw_Droit ())									// Si on a les deuxc switchs ...
		Force_Propulsion(X_Propulsion(),2049,-1571);						// ... recalle le robot sur le bord	
	else																	// Sinon
	{													
			ToutDroit_Propulsion (1500, -20);								// Tant pis, on recule ...
			while (	Etat_Propulsion ()!='g' &&								// Jusqu' ce que l'on soit de nouveau bloqu ...
					Etat_Propulsion ()!='a');								// ... ou arriv
	}
		
	Stop_Propulsion();														// On arrte les moteurs, car on est call !
	return NbEvitements;													// On retourne le nombre d'vitements
}*/





// --------------------------------------------------------------------------
/* Avance et oriente lgrement le robot dans le sens de la pente
 * puis depose les balles
 * Arguments : 
 * 	- la couleur que l'on va jouer durant ce match
 * 
 * Paramtre retourn : 
 *   0 : tout s'est bien pass,
 * 	-1 : Une collision s'est produite sur le BUS IC ou l'esclave n'a pas renvoy d'acknoledgment aprs l'adresse
*/
void Depose_Balles (char Couleur)
{	
//	static char DerniereCouleur=NONE;						// Couleur de la dernire balle dpose
//	char NbBlanche,NbCouleur;								// Variables contenant le nombre de balles blanches et de couleur
//	char Side='g';											// Dtermine le ct de dpose
	
	ToutDroit_Propulsion (10,20);							// Avance le robot de 2 cm
	while (Etat_Propulsion ()!='a');

	if (Couleur==ROUGE)										// Si on joue rouge
	{
		if (X_Propulsion()>1500) 							// Si on est du ct rouge ...
			DeposeBalle_Chez_Nous_Barillet();				// ... on dpose chez nous
		else												// sinon ...
			DeposeBalle_Adverse_Barillet();					// ... on dpose chez l'adversaire
	}
	else													// On joue Bleu
	{
		if (X_Propulsion()<=1500) 							// Si on est du ct bleu ...
			DeposeBalle_Chez_Nous_Barillet();				// ... on dpose chez nous
		else												// sinon ...
			DeposeBalle_Adverse_Barillet();					// ... on dpose chez l'adversaire
	}	
	
	Delay10KTCYx(250);		
	while (Barillet_Busy());
}	




// --------------------------------------------------------------------------
/* Routine d'vitement du robot adverse :
 * On tourne le robot pour avoir l'adversaire soit sur un ct gauche ou droit  90
 * Puis on regarde s'il est devant ou derrire et on avance ou recule en consquence 
 * La distance parcouru est dpendante de la nouvelle position du robot
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *  aucun
*/
void Evite_Robot_Adverse(unsigned char Nb_Evit)
{
	float 			Angle_Adverse;											// Angle form avec le robot adverse
	float 			Angle_Robot;											// Orientation courante du robot
	int				X,Y;
	
	Stop_Propulsion();
	while (Etat_Propulsion()!='a');
	
	X=X_Propulsion();
	Y=Y_Propulsion();
	
	if (X<600 && Y<600) 	 											// Si le robot est dans le coin rouge
	{	
		print_str("Evit Coin Rouge\n");
		if (Angle_Absolu_Robot_Adverse()>PI/4)
		{
			Angle_Propulsion (PI,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(1350,600,-60);
			while (IsMove_Propulsion());
			return;
		}
		else
		{
			Angle_Propulsion (-PI/2,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(600,1350,-60);
			while (IsMove_Propulsion());					
			return;
		}	
	}
	
	if (X>2400 && Y<600) 												// Si le robot est dans le coin bleu
	{
		print_str("Evit Coin Bleu\n");
		if (Angle_Absolu_Robot_Adverse()<3*PI/4)
		{
			Angle_Propulsion (0,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(1350,600,-60);
			while (IsMove_Propulsion());
			return;
		}
		else
		{
			Angle_Propulsion (-PI/2,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(2150,1200,-60);
			while (IsMove_Propulsion());			
			return;
		}	
	}
	if (X>2400 && Y>1500) 												// On est coinc du cot du conteneur rouge
	{
		print_str("Evit Cont Rouge\n");
		if (Angle_Absolu_Robot_Adverse()>-3*PI/4 &&
			Angle_Absolu_Robot_Adverse()<PI/4)
		{
			Angle_Propulsion (PI,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(1750,1500,60);
			while (IsMove_Propulsion());
			return;
		}
		else
		{
			Angle_Propulsion (-PI/2,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(2400,750,60);
			while (IsMove_Propulsion());
			return;
		}	
	}
	
	if (X<600 && Y>1500) 												// On est coinc du ct du conteneur bleu
	{
		print_str("Evit Cont Bleu\n");
		if (Angle_Absolu_Robot_Adverse()>-PI/4)			
		{
			Angle_Propulsion (-PI/2,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(600,750,60);
			while (IsMove_Propulsion());
			return;
		}
		else
		{
			Angle_Propulsion (0,30);
			while (IsMove_Propulsion());
			GotoXY_Propulsion(1350,1500,60);
			while (IsMove_Propulsion());
			return;
		}	
	}
	
	
	
	
	//----------- Phase 0, on fait l'acquisition de toutes les donnes (capteur, position de l'adversaire ...)
	
	if (Distance_Robot_Adverse()==0)										// Si on ne sait pas ou se trouve le robot adverse
		Angle_Adverse=0;													// On suppose qu'il est pile en face
	else
	{
		Angle_Adverse=Angle_Robot_Adverse();								// Mesure de l'angle du robot adverse
		Angle_Adverse=Angle_Adverse*2.0*PI/255.0;							// Conversion l'angle de l'adversaire en radians		
	}
	Angle_Robot=A_Propulsion()/1000.0;										// Mesure et convertit l'angle du robot en radian
		
		
		
	//----------- Phase 0bis, on recule ou on avance si ncessaire
	
	if (Adversaire_Devant()==3 && Adversaire_Derriere()!=3)
	{
		ToutDroit_Propulsion (100,-40);
		while (IsMove_Propulsion());
	}
	
	if (Adversaire_Derriere()==3 && Adversaire_Devant()!=3)
	{
		ToutDroit_Propulsion (100,40);
		while (IsMove_Propulsion());
	}
	
	
	
	//----------- Phase 1, on tourne de faon  avoir l'adversaire sur le ct
	
	if (Angle_Adverse>=0 && Angle_Adverse<=PI)								// Si le robot adverse est sur le ct droit
	{
		Angle_Propulsion (Angle_Robot-PI/2+Angle_Adverse,40);				// On tourne pour se positionner  90
		while (	Etat_Propulsion ()!='a');									// On attends la fin du mouvement						
	}
	else																	// Si le robot adverse est  gauche
	{
		Angle_Propulsion (Angle_Robot-1.5*PI+Angle_Adverse,40);				// On tourne pour se positionner  90
		while (	Etat_Propulsion ()!='a');									// On attends la fin du mouvement						
	}
	
	
	
	//----------- Phase 2, on avance ou on recule
	
	Delay10KTCYx(150);														// Attends avant de faire une nouvelle mesure sur la tourelle

	if (Distance_Robot_Adverse()==0)										// Si on ne sait pas ou se trouve le robot adverse
		Angle_Adverse=63;													// On prends le cas le plus dfavorable
	else
		Angle_Adverse=Angle_Robot_Adverse();								// On mesure la nouvelle position de l'adversaire
	
		
	if (Nb_Evit==1)															// Si on est au premier vitement 
	{
		if (Angle_Adverse>56 && Angle_Adverse<72)							// et que le robot ne bouge pas
		{
			Nb_Evit=2;
		}
		else if (Angle_Adverse>184 && Angle_Adverse<200)					//	et que le robot ne bouge pas
		{
			Nb_Evit=2;
		}		
	}
	
	if (Y_Propulsion()<500)													// Le robot est proche de la longueur distributeur
	{
		if (A_Propulsion()<0)												// Selon son orientation, 
			ToutDroit_Propulsion (450,-VIT_EVIT);							// On avance vers le centre de la table
		else
			ToutDroit_Propulsion (450,VIT_EVIT);							// Ou on recule vers le centre de la table	
		while (IsMove_Propulsion());		
	}
	else if (Y_Propulsion()>1600)											// Le robot est proche du conteneur
	{
		if (A_Propulsion()<0)												// Selon son orientation, 
			ToutDroit_Propulsion (450,VIT_EVIT);							// On avance vers le centre de la table
		else
			ToutDroit_Propulsion (450,-VIT_EVIT);							// Ou on recule vers le centre de la table			
		while (IsMove_Propulsion());		
	}
	else if (X_Propulsion()<500)													// Notre robot est proche de la largeur bleue
	{
		if (A_Propulsion()<1571 && A_Propulsion()>-1571)					// Selon son orientation, 
			ToutDroit_Propulsion (450,VIT_EVIT);							// On avance vers le centre de la table
		else
			ToutDroit_Propulsion (450,-VIT_EVIT);							// Ou on recule vers le centre de la table			
		while (IsMove_Propulsion());				
		
	}
	else if (X_Propulsion()>2500)											// Le robot est proche de la largeur rouge
	{
		if (A_Propulsion()<1571 && A_Propulsion()>-1571)					// Selon son orientation, 
			ToutDroit_Propulsion (450,-VIT_EVIT);							// On avance vers le centre de la table
		else
			ToutDroit_Propulsion (450,VIT_EVIT);							// Ou on recule vers le centre de la table	
		while (IsMove_Propulsion());				
	}
	else {
		if (Angle_Adverse<64.0)													// On regarde dans quel cadran se trouve le robot adverse
			ToutDroit_Propulsion ((int)(Angle_Adverse*8.0*Nb_Evit),VIT_EVIT);			// On avance d'une distance relative  l'angle du robot
		else if (Angle_Adverse<128.0)											// On est dans le 2me cadran
			ToutDroit_Propulsion ((int)((128.0-Angle_Adverse)*8.0*Nb_Evit),-VIT_EVIT);	// On recule d'une distance relative  l'angle du robot
		else if (Angle_Adverse<192.0)											// On est dans le 3me cadran
			ToutDroit_Propulsion ((int)((Angle_Adverse-128)*8.0*Nb_Evit),-VIT_EVIT);	// On recule d'une distance relative  l'angle du robot
		else 																	// On est dans le 4me cadran
			ToutDroit_Propulsion ((int)((255-Angle_Adverse)*8.0*Nb_Evit),VIT_EVIT);		// On avance d'une distance relative  l'angle du robot
		while (	Etat_Propulsion ()!='a'	&&										// Jusqu' ce la fin du mouvement ...	
				Etat_Propulsion ()!='g' &&										// ... ou que le robot est bloqu ...
				X_Propulsion()>400 &&											// ... ou il trop proche des bords
				X_Propulsion()<2600 &&
				Y_Propulsion()>400 &&
				Y_Propulsion()<1700);
	}
	Stop_Propulsion();
	while (Etat_Propulsion()!='a');
	Delay10KTCYx(10);
	
	
	//----------- Phase 3, On revient sur l'orientation initiale	
/*	
	if (Sens)
		Angle_Propulsion (Angle_Robot+PI,VIT_EVIT);								// On tourne pour revenir dans la position initiale
	else
		Angle_Propulsion (Angle_Robot,VIT_EVIT);								// On tourne pour revenir dans la position initiale
	while (	Etat_Propulsion ()!='a');											// Jusqu' la fin du mouvement
*/
}







//-----------------------------------------------------------------------
/* Le robot se place en dfense de notre ct en protgeant les balles
 *
 * Arguments : 
 * 	aucun
 * 
 * Paramtre retourn : 
 *	 aucun
 */
void Defense_Bleu(void)
{
		/*
	if (Y_Propulsion()<1700) 													// Si on est dj du ct du conteneur standard 
		Goto_Conteneur (1100);													// Envoie le robot contre le conteneur de notre ct c'est mieux..	


	if (X_Propulsion()<1000 || Y_Propulsion()>1200)								// Si on est pas  l'endroit souhait
	{
		//ToutDroit_Propulsion(200,20);											// On avance
		GotoXY_Propulsion (X_Propulsion(),1900,20);
		while(IsMove_Propulsion());		
		
		if (X_Propulsion()<1000)
			Angle_Propulsion(PI,30);											// On s'oriente pour reculler
		else
			Angle_Propulsion(0,30);												// On s'oriente pour reculler
		while(IsMove_Propulsion());				

		GotoXY_Propulsion (1100,1800,-60);										// On tente d'aller au point
		while (Etat_Propulsion()!='a')
		{				
			
			if (Adversaire_Derriere()>=2)
			{
				Stop_Propulsion();
				while (Adversaire_Derriere()>=2);
				GotoXY_Propulsion (1100,1800,-40);								// On repart ...	
			}					
		}		
	}
	Angle_Propulsion(-PI/2.0,30);
	while(IsMove_Propulsion());	
	
	Recal_Arriere();
	*/
	while (1)
	{
		LCD_GotoXY(1,3);										// On affiche le temps qui reste
		print_int (90-Sec_depuis_debut ());					// 
		print_str ("  ");
		Delay10KTCYx(30);
	}	
} 







/** indique si l'adversaire est prsent devant 
  * Arguments :
  *		aucun
  * Valeur renvoye :
  *		-1 si on ne sait pas o est la balise adverse
  *		0 si adversaire pas devant
  *		1 si adversaire loin devant
  *		2 si adversaire proche devant
  *		3 si adversaire au contact devant
  */
int Adversaire_Devant( void ){
	int angle_adv;
	int teleD, teleG;
	int adv_vu;
	
	angle_adv = Angle_Robot_Adverse();
	adv_vu = Distance_Robot_Adverse();
		
	// s'il est devant nous ou qu'on ne sait pas o il est
	if(  (angle_adv>=95 && angle_adv<=159) || !adv_vu ){
		Delay100TCYx(1);
		teleD = Telemetre_Avant_Droit();
		Delay100TCYx(1);
		teleG = Telemetre_Avant_Gauche();
		
		// et s'il est proche de nous
		if( teleD>DISTANCE_OBSTACLE || teleG>DISTANCE_OBSTACLE ){
			if( teleD>DISTANCE_CONTACT || teleG>DISTANCE_CONTACT )
				return 3;
			else
				return 2;
		}
		
		if( adv_vu )
			return 1;
		else
			return -1;
	}
	
	// autrement, on retourne 0
	return 0;
}

/** indique si l'adversaire est prsent derrire
  * Arguments :
  *		aucun
  * Valeur renvoye :
  *		-1 si on ne sait pas o est la balise adverse
  *		0 si adversaire pas derrire
  *		1 si adversaire loin derrire
  *		2 si adversaire proche derrire
  *		3 si adversaire au contact derrire
  */	
int Adversaire_Derriere( void ){
	int angle_adv;
	int teleD;
	int adv_vu;
	
	angle_adv = Angle_Robot_Adverse();
	Delay10TCYx(1);
	adv_vu = Distance_Robot_Adverse();		
	
	// s'il est derrire nous ou qu'on ne sait pas o il est
	if(  angle_adv>=223 || angle_adv<=32 || !adv_vu ){
		teleD = Telemetre_Arriere();
		// et s'il est proche de nous
		if( teleD>DISTANCE_OBSTACLE){
			if( teleD>DISTANCE_CONTACT )
				return 3;
			else
				return 2;
		}
		
		if( adv_vu )
			return 1;
		else
			return -1;
	}
	
	// autrement, on retourne 0
	return 0;
}
